﻿// <summary>ソースコード：ダム（一定量、定率定量方式）モデル共通定義クラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

// ToDo namespace は　モデル開発者が変更して、ユニークな名称にして下さい
namespace jp.or.jccajsce.DamConstantRateDischargingModel
{
    /// <summary><para>class outline:</para>
    /// <para>ダム（一定量、定率定量方式）モデル共通定義クラス</para>
    /// </summary>
    /// <remarks>
    /// <para>Remarks:</para>
    /// <para>本クラスは、必須ではないが、使用の便利さの為、常数等の定義を一つに纏めておく</para>
    /// <para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2014/08][新規作成]</para>
    /// </remarks>
    public class DamConstantRateDischargingDefine
    {


        //********************************
        //===== ファクトリ関連定義 ========
        //********************************
        /// <summary>ダム（一定量、定率定量方式）モデルファクトリ識別子</summary>
        public static HySID MODEL_FACTORY_LIB_ID = new HySID("jp.or.jccajsce.DamConstantRateDischarging_Factory");


        //********************************
        //===== モデル関連定義 ========
        //********************************

        /// <summary>ダム（一定量、定率定量方式）モデル種別</summary>
        public static readonly HySObjectKind DamConstantRateDischarging_MODEL_KIND = new HySObjectKind("jp.or.jccajsce.DamConstantRateDischarging_Model");
        /// <summary>ダム（一定量、定率定量方式）モデル名称</summary>
        public static readonly HySString DamConstantRateDischarging_MODEL_NAME = new HySString(Properties.Resources.STRING_STATEMODULE_INFO);

        /// <summary>流量（流入量）一次元時系列</summary>
        public static readonly HySID IN_PATTERN = new HySID("InFlow");

        /// <summary>流量（放流量）一次元時系列</summary>
        public static readonly HySID OUT_FLOW_PATTERN = new HySID("OutFlow");
        /// <summary>貯水位一次元時系列</summary>
        public static readonly HySID OUT_STAGE_PATTERN = new HySID("OutStage");
        /// <summary>貯水量一次元時系列</summary>
        public static readonly HySID OUT_STORAGE_PATTERN = new HySID("OutStorage");

        /// <summary>流量（流入量）ポイント時系列</summary>
        public static readonly HySID IN_PATTERN_P = new HySID("InFlow.Point");
        /// <summary>流量（放流量）ポイント時系列</summary>
        public static readonly HySID OUT_FLOW_PATTERN_P = new HySID("OutFlow.Point");
        /// <summary>貯水位ポイント時系列</summary>
        public static readonly HySID OUT_STAGE_PATTERN_P = new HySID("OutStage.Point");
        /// <summary>貯水量ポイント時系列</summary>
        public static readonly HySID OUT_STORAGE_PATTERN_P = new HySID("OutStorage.Point");
    }
}
