﻿// <summary>ソースコード：ダム（一定量、定率定量方式）モデルファクトリクラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

using CommonMP.HYMCO.Interface;
using CommonMP.HYMCO.Interface.Model;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.Interface.Controller;

using CommonMP.HYSSOP.CoreImpl;
using CommonMP.HYMCO.CoreImpl.Model;
using CommonMP.HYMCO.CoreImpl.Data;

using CommonMP.HYMCO._SYSTEM_;
namespace CommonMP.HYMCO._SYSTEM_
{
    /// <summary><para>class outline:</para>
    /// <para>ダム（一定量、定率定量方式）モデルファクトリ生成</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2014/08][新規作成]</para>
    /// </remarks>
    public class HYMCO_MODEL_FACTORY_CREATOR_IMPLE : HYMCO_MODEL_FACTORY_CREATOR
    {
        /// <summary><para>method outline:</para>
        /// <para>コンストラクター</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HYMCO_MODEL_FACTORY_CREATOR_IMPLE csFactCrt = new HYMCO_MODEL_FACTORY_CREATOR_IMPLE( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>生成インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public HYMCO_MODEL_FACTORY_CREATOR_IMPLE()
        {
        }
        /// <summary><para>method outline:</para>
        /// <para>演算モデルファクトリクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McModelFactory csCalModelFactory = CreateFactory( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>演算モデルファクトリクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public CommonMP.HYMCO.Interface.Model.McModelFactory CreateFactory()
        {
            return new jp.or.jccajsce.DamConstantRateDischargingModel.DamConstantRateDischargingFactory();
        }
    }
}

// ToDo namespace は　モデル開発者が変更して、ユニークな名称にして下さい
namespace jp.or.jccajsce.DamConstantRateDischargingModel
{
    /// <summary><para>class outline:</para>
    /// <para>ダム（一定量、定率定量方式）モデルファクトリクラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2010/02][新規作成]</para>
    /// </remarks>
    public class DamConstantRateDischargingFactory : McBasicModelFactoryBase
    {
        /// <summary><para>method outline:</para>
        /// <para>ファクトリ識別子を生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HySID csFactID = CreateFactoryID( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>ファクトリ識別子</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override HySID CreateFactoryID()
        {
            // ToDo 本ファクトリクラスにユニークな識別子を生成して返してください
            return DamConstantRateDischargingDefine.MODEL_FACTORY_LIB_ID;
        }

        /// <summary><para>method outline:</para>
        /// <para>演算モデルクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalModel csCalModel = CreateCalModel(csModelKind) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>演算モデルクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalModel CreateCalModel(HySObjectKind csModelKind)
        {
            McBasicCalculateModelBase csCalModel = null;

            if (csModelKind.Equals(DamConstantRateDischargingDefine.DamConstantRateDischarging_MODEL_KIND) == true)
            {
                csCalModel = new DamConstantRateDischargingModel();
            }
            else
            {
                // Do Nothing
            }

            return csCalModel;
        }

        /// <summary><para>method outline:</para>
        /// <para>要素内演算中データクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McCalInfo csCalModel = CreateCalInfo( csModelKind ) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>要素内演算中データクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalInfo CreateCalInfo(HySObjectKind csModelKind)
        {
            McCalInfo csCalInfoData = null;

            if (csModelKind.Equals(DamConstantRateDischargingDefine.DamConstantRateDischarging_MODEL_KIND) == true)
            {
                csCalInfoData = new DamConstantRateDischargingCalInfo();
            }
            else
            {
                // Do Nothing
            }

            return csCalInfoData;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデルプロパティ表示／設定情報クラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csPropertyInf = CreateModelPropertyInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>モデルプロパティ表示／設定情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCellModelPropertyIF CreateModelProperty(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            McCellModelPropertyInfo csRtnCellPrptyDt = null;

            if (csModelKind == DamConstantRateDischargingDefine.DamConstantRateDischarging_MODEL_KIND)
            {
                csRtnCellPrptyDt = new DamConstantRateDischargingPropertyInfo(csLibraryID, csModelKind);

                csRtnCellPrptyDt.SetStepTime(600); // δT設定

                csRtnCellPrptyDt.AddInfoType("m_dQc", Properties.Resources.STRING_QUANTITY_CUT, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dQc", 300.0);
                csRtnCellPrptyDt.AddInfoType("m_da", Properties.Resources.STRING_RATE, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_da", 0.500);
                csRtnCellPrptyDt.AddInfoType("m_dQmax", Properties.Resources.STRING_MAXIMUM_OUTFLOW, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dQmax", 1500.0);
                csRtnCellPrptyDt.AddInfoType("m_dDamH1", Properties.Resources.STRING_ROBISOS_LEVEL, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dDamH1", 150.0);
                csRtnCellPrptyDt.AddInfoType("m_bato", Properties.Resources.STRING_CONDITION, McDefine.ValKind.BOOL);
                csRtnCellPrptyDt.SetInfo("m_bato", false);
                csRtnCellPrptyDt.AddInfoType("m_dDamH2", Properties.Resources.STRING_CONTROL_LEVEL, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dDamH2", 125.0);
                csRtnCellPrptyDt.AddInfoType("m_sHvFile", Properties.Resources.STRING_HV_DATEBASE, McDefine.ValKind.STRING);
                csRtnCellPrptyDt.SetInfo("m_sHvFile", "HVTable.csv");

                // 受信可能なパターン
                {// 流量（流入量）
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        DamConstantRateDischargingDefine.IN_PATTERN, McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_QUANTITY_IN) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                           csCellChara.SetDataKind(0, Properties.Resources.STRING_QUANTITY_IN, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR); // 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);

                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        DamConstantRateDischargingDefine.IN_PATTERN_P, McTranInfoDefine.SINGLE_CELL_SERIAL,
                         Properties.Resources.STRING_QUANTITY_IN) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_QUANTITY_IN, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR);// 内挿方法設定
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);


                  }

                // 送信パターンの設定
                {// 流量（放流量）（１次元時系列）
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        DamConstantRateDischargingDefine.OUT_FLOW_PATTERN, McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_QUANTITY_OUT) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_QUANTITY, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);

                    // 流量（放流量）（ポイント時系列）
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                    DamConstantRateDischargingDefine.OUT_FLOW_PATTERN_P, McTranInfoDefine.SINGLE_CELL_SERIAL,
                    Properties.Resources.STRING_QUANTITY_OUT) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_QUANTITY, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);



                    // 貯水位（１次元時系列）
                   csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        DamConstantRateDischargingDefine.OUT_STAGE_PATTERN, McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_RESERVOIR_LEVEL) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_RESERVOIR_LEVEL, HySDataKindDefine.WATER_LEVEL, "m");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);

                    // 貯水位（ポイント時系列）
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                         DamConstantRateDischargingDefine.OUT_STAGE_PATTERN_P, McTranInfoDefine.SINGLE_CELL_SERIAL,
                         Properties.Resources.STRING_RESERVOIR_LEVEL) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_RESERVOIR_LEVEL, HySDataKindDefine.WATER_LEVEL, "m");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);


                    
                    // 貯水量（１次元時系列）
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        DamConstantRateDischargingDefine.OUT_STORAGE_PATTERN, McTranInfoDefine.D1_CELL_SERIAL,
                        Properties.Resources.STRING_STORAGE_VOLUME) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_STORAGE_VOLUME, HySDataKindDefine.WATER_VOLUME, "m3");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);

                    // 貯水量（ポイント時系列）
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                        DamConstantRateDischargingDefine.OUT_STORAGE_PATTERN_P, McTranInfoDefine.SINGLE_CELL_SERIAL,
                        Properties.Resources.STRING_STORAGE_VOLUME) as McTranInfoPattern;
                    {// セル内変数の設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_STORAGE_VOLUME, HySDataKindDefine.WATER_VOLUME, "m3");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);
                                    
                }
              }   
            
            else
                {
                // Do Noghing
            }

            return csRtnCellPrptyDt;
        }
        /// <summary><para>method outline:</para>
        /// <para>モデル初期化表示／設定情報生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McPropertyInfoRoot csInitialInf = CreateModelInitialInfo(csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>初期情報情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McPropertyInfoRoot CreateModelInitialInfo(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            McInitialInfo csRtnDt = null;

            if (csModelKind.Equals(DamConstantRateDischargingDefine.DamConstantRateDischarging_MODEL_KIND) == true)
            {
                csRtnDt = new DamConstantRateDischargingInitialData(csLibraryID, csModelKind);

                csRtnDt.AddInfoType("m_dInitStage", Properties.Resources.STRING_RESERVOIR_LEVEL_INI, McDefine.ValKind.DOUBLE);
                csRtnDt.SetInfo("m_dInitStage", 107.0);
            }
            else
            {
                // Do Nothing
            }

            return csRtnDt;
        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>モデル情報提供</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>HySDataLinkedList csModelInfoList = GetCalModelInfoList();</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>モデル情報のリスト</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>モデル情報(McModelInfo)をリスト形式で返却する</para>
        /// </remarks>
        public override HySDataLinkedList GetCalModelInfoList()
        {
            McModelInfo csModelInfo = null;

            csModelInfo = new McModelInfo(
                                          (HySID)this.GetFactoryID(),
                                          McModelLibraryDefine.DIVISION_CALCULATION_MODEL,
                                          new HySObjectKind("CAL_DAM_MODELS"),
                                          DamConstantRateDischargingDefine.DamConstantRateDischarging_MODEL_KIND,
                                          DamConstantRateDischargingDefine.DamConstantRateDischarging_MODEL_NAME
                                         );

            csModelInfo.SetVersionInf(Properties.Resources.STRING_VERSION); // モデルのバージョン
            csModelInfo.SetSummaryInf(Properties.Resources.STRING_STATEMODEL_INFO); // モデルの簡単な説明
            csModelInfo.SetCreatorInf(Properties.Resources.STRING_DESIGNER); // モデル開発者名
            csModelInfo.SetIconName(new HySString("jp.or.jccajsce.DamConstantRateDischarging")); // To Do モデル固有アイコン（アイコンを使用しないときは "DefaultModel" を設定してください）
            csModelInfo.SetManualFileName(@"jp.or.jccajsce.DamConstantRateDischargingModel_Factory\jp.or.jccajsce.DamConstantRateDischarging.pdf"); // To Do モデル固有の解説情報等あれば設定してください。
            m_csCalModelInforList.AddLast(csModelInfo); // 演算モデル情報の追加
            //<@Add_GetCalModelInfoList/> ウイザードによる追加の目印　目印を削除しないで下さい　削除した場合には、モデルの追加は、手動で行う必要があります。
            return m_csCalModelInforList;

        }

    }
}
